package cn.com.tenlion.systembase.service.linecase;

import cn.com.tenlion.systembase.pojo.bos.linecase.LineCaseBO;
import cn.com.tenlion.systembase.pojo.dtos.linecase.LineCaseDTO;
import cn.com.tenlion.systembase.pojo.pos.linecase.LineCasePO;
import cn.com.tenlion.systembase.pojo.vos.linecase.LineCaseVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: ILineCaseService
 * @Description: 涉及线、路案（事）件
 * @Author: CodeFactory
 * @Date: 2021-10-13 14:58:15
 * @Version: 3.0
 **/
public interface ILineCaseService {

    /**
     * 新增涉及线、路案（事）件
     *
     * @param lineCaseVO
     * @return
     */
    void save(LineCaseVO lineCaseVO);

    /**
     * 新增涉及线、路案（事）件
     *
     * @param token
     * @param lineCaseVO
     * @return
     */
    void save(String token, LineCaseVO lineCaseVO);

    /**
     * 新增涉及线、路案（事）件
     *
     * @param lineCaseVO
     * @return lineCaseId
     */
    String saveReturnId(LineCaseVO lineCaseVO);

    /**
     * 新增涉及线、路案（事）件
     *
     * @param token
     * @param lineCaseVO
     * @return lineCaseId
     */
    String saveReturnId(String token, LineCaseVO lineCaseVO);

    /**
     * 删除涉及线、路案（事）件
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除涉及线、路案（事）件
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除涉及线、路案（事）件（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改涉及线、路案（事）件
     *
     * @param lineCaseId
     * @param lineCaseVO
     * @return
     */
    void update(String lineCaseId, LineCaseVO lineCaseVO);

    /**
     * 修改涉及线、路案（事）件
     *
     * @param token
     * @param lineCaseId
     * @param lineCaseVO
     * @return
     */
    void update(String token, String lineCaseId, LineCaseVO lineCaseVO);

    /**
     * 涉及线、路案（事）件详情
     *
     * @param params 参数Map
     * @return
     */
    LineCaseDTO get(Map<String, Object> params);

    /**
     * 涉及线、路案（事）件详情
     *
     * @param lineCaseId
     * @return
     */
    LineCaseDTO get(String lineCaseId);

    /**
     * 涉及线、路案（事）件详情
     *
     * @param params 参数Map
     * @return
     */
    LineCaseBO getBO(Map<String, Object> params);

    /**
     * 涉及线、路案（事）件详情
     *
     * @param lineCaseId
     * @return
     */
    LineCaseBO getBO(String lineCaseId);

    /**
     * 涉及线、路案（事）件详情
     *
     * @param params 参数Map
     * @return
     */
    LineCasePO getPO(Map<String, Object> params);

    /**
     * 涉及线、路案（事）件详情
     *
     * @param lineCaseId
     * @return
     */
    LineCasePO getPO(String lineCaseId);

    /**
     * 涉及线、路案（事）件列表
     *
     * @param params
     * @return
     */
    List<LineCaseDTO> list(Map<String, Object> params);

    /**
     * 涉及线、路案（事）件列表
     *
     * @param params
     * @return
     */
    List<LineCaseBO> listBO(Map<String, Object> params);

    /**
     * 涉及线、路案（事）件列表
     *
     * @param params
     * @return
     */
    List<LineCasePO> listPO(Map<String, Object> params);

    /**
     * 涉及线、路案（事）件分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<LineCaseDTO>> listPage(ListPage page);

    /**
     * 涉及线、路案（事）件统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

}